#!/usr/bin/env ruby
# This software is distributed under the terms of the new BSD License.
# Copyright (c) 2008, 2014 molelord
# All rights reserved.

# This script creates component declarations from VHDL files.
# Usually, This script is called by "rake" command.
#
# Usage : compo.rb FOOBAR.vhd > FOOBAR_PKG.vhd

for i in ARGV do
    if i =~ /\.vhd$/

        # packageはcomponent宣言自動作成の対象から外す。
        next if i =~ /_pkg\.vhd$/

        remove_is = false
        inner     = false
        f = open(i, "r")
        while line = f.gets()
            line = line.encode("UTF-16BE", "UTF-8", :invalid => :replace,
                :undef => :replace, :replace => '?').encode("UTF-8")
            if line =~ /^\s*--/
                if line =~ /^\s*--\s*synthesis\s*translate_o[nf]f*/
                    print line
                end
                next
            end

            if line =~ /^\s*entity/i
                line.sub!(/entity/i, "component")
                remove_is = true
                inner = true

                name = line.sub(/^.*component\s*/, "")
                name =~ /^\S+/
                name = $&
                #printf "package %s_pkg is\n\n", name
            end

            if remove_is
                line.sub!(/\s*\bis\b/i, "")
                remove_is = false
            end

            if line.sub!(/\bend\s*\w*\s*;/i, "end component;")
               print line
               print "\n"
               inner = false
               break
            end

            if inner
                print line
            end
        end
        f.close
    end
end

#print "\n"
#print "end; -- package\n"
#print "\n"
#printf "package body %s_pkg is\n", name
#print "end; -- package body\n"
