-- This software is distributed under the terms of the new BSD License.
-- Copyright (c) 2014 molelord
-- All rights reserved.

-- リセット信号用デバウンスフィルタのテストベンチ

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.compo_pkg.all;

entity debounce_rst_tb is
end debounce_rst_tb;

architecture sim of debounce_rst_tb is

    signal clk      : std_logic := '0';
    signal rst      : std_logic := '0';
    signal rstout   : std_logic;

    constant HALFCYCLE : time := 12.5 ns; -- 40MHz

begin

    clock : process
    begin
        wait for HALFCYCLE;
        while true loop
            wait for HALFCYCLE;
            clk <= not clk;
        end loop;
    end process;

    reset : process
    begin
        wait for 10 ms;
        rst <= '1';
        wait for 1 ms;
        rst <= '0';
        wait for 1 ms;
        rst <= '1';
        wait for 1 ms;
        rst <= '0';
        wait for 1 ms;
        rst <= '1';
        wait for 100 ms;

        rst <= '0';
        wait for 1 ms;
        rst <= '1';
        wait for 1 ms;
        rst <= '0';
        wait for 1 ms;
        rst <= '1';
        wait for 1 ms;
        rst <= '0';
        wait for 100 ms;

        rst <= '1';
        wait;
    end process;

    dut : debounce_rst
    generic map (
        INIT   => '0',
        CLK_HZ => 40000000
    )
    port map (
        clk_i => clk,
        rst_i => rst,
        rst_o => rstout
    );

end sim;
