-- This software is distributed under the terms of the new BSD License.
-- Copyright (c) 2014 molelord
-- All rights reserved.

-- TD4(とりまき含む)向けのテストベンチ

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

use work.compo_pkg.all;

entity td4shell_tb is
end td4shell_tb;

architecture sim of td4shell_tb is

    signal clk      : std_logic := '0';
    signal rst      : std_logic := '1';
    signal gpio_dip : std_logic_vector(3 downto 0) := "1000"; -- 10Hz設定
    signal gpio_led : std_logic_vector(3 downto 0);

    constant HALFCYCLE : time := 12.5 ns; -- 40MHz

begin

    clock : process
    begin
        wait for HALFCYCLE;
        while true loop
            wait for HALFCYCLE;
            clk <= not clk;
        end loop;
    end process;

    reset : process
    begin
        for i in 1 to 3 loop
            wait for HALFCYCLE;
        end loop;
        rst <= '1';

        wait for 100 ms;
        rst <= '0' after 2 ns;

        wait;
    end process;

    dut : td4shell
    port map (
        user_clock_i => clk,
        user_reset_i => rst,
        gpio_dip_i   => gpio_dip,
        gpio_led_o   => gpio_led
    );

end sim;
